$(document).ready(function() {
    var Data = {
        datetaime_format: 'DD-MM-YY',
        table_timeout: '',
        popups: {
            'report-new': '.popup_new_dataset',
            'subscribe': '.popup_subscribe',
            'report-passport': '.popup_passport_error',
            'report-new-data': '.popup_add_row',
            'report-update': '.popup_dataset_renew'
        }
    };
    var TableVar;
    var MAX_ARRAY_ITEMS=10;
    var Act = {
        init: function() {
            Act.initDownloadButtons();
            if ($('.filters_aside').length) {
                Data.categories = {};
                var c = false;
                if (window.location.hash) {
                    c = decodeURIComponent(window.location.hash.substr(1));
                }
                $('.filter_aside_block').each(function(i,e) {
                    var t = $(e).text();
                    if ($(e).data('cat'))
                        Data.categories[$(e).data('cat').replace(/"/g, '')] = t;
                    if (c && c.toLowerCase() == t.toLowerCase()) {
                        $(e).addClass('active').siblings().removeClass('active');
                    }
                });
            }
            if ($('#datasets_wrapper').length) {
                Act.buildPaginator();
                Act.reloadDatasets();
                Act.initFiltersScroll();
                var hash = window.location.hash;
                if (hash.length > 1) {
                    hash = hash.substr(1);
                    if ($(Data.popups[hash]).length) {
                        Act.showPopup(Data.popups[hash])
                    }
                }

            }
            if ($('#stats_wrapper').length) {
                Act.buildPaginator();
                Act.reloadDatasetsStat();
                Act.initFiltersScroll();
            }
            if ($('#dataset_content').length) {
                var hash = Act.changeHash('');
                if (hash && hash.tab) {
                    Act.switchTab($('.'+hash.tab));
                }
                if (hash && hash.popup) {
                    if ($(Data.popups[hash.popup]).length) {
                        Act.showPopup(Data.popups[hash.popup])
                    }
                }
                Act.getDataset();
                Act.getDatasetRating();

                var prev_obj;
                var hash = decodeURIComponent(window.location.hash.substr(1));
                if (hash.length > 1) {
                    try {
                        prev_obj = JSON.parse(hash);
                    } catch (e) {
                        console.log(e);
                    }
                }
                $(window).on('hashchange', function() {
                    var obj;
                    var hash = decodeURIComponent(window.location.hash.substr(1));
                    if (hash.length > 1) {
                        try {
                            obj = JSON.parse(hash);
                        } catch (e) {
                            console.log(e);
                        }
                    }
                    if (prev_obj && obj.schema != prev_obj.schema) {
                        $('#historyContainer .closeWindow').click();
                        $('#schema_select').val(obj.schema).trigger('change');
                        prev_obj = obj;
                    }
                });
            }
            if ($('#about_content').length) {
                Act.fillAboutLists();
            }
            if ($('#search_wrapper').length) {
                Act.initSearch();
            }
            if ($('.dataset_share_btn').length) Act.initShareBtns();
        },
        initDownloadButtons: function() {
            $('.download_btn').not('.init').each(function(i,e) {
                if ($(e).parents('#templates_wrapper').length) return;
                $(e).append('<div class="download_formats"></div>');
                var ff = $(e).data('formats').split(',');
                for (var f in ff) {
                    $(e).find('.download_formats').append('<div class="download_format">' + ff[f] + '</div>');
                }
                if ($(e).data('link')) {
                    $(e).find('.download_formats').append('<a href="' + $(e).data('link') + '">Открыть</a>');
                }
                $(e).addClass('init');
            });
        },
        startDownload: function(elem) {
            var f = elem.text().toLowerCase();
            var name = elem.parents('.download_btn').data('name');
            var url;
            if (name) {
                url = elem.parents('.download_btn').data('url') + (name ? name : '') + '.' + f + '?e={"attachment":true, "format":"' + f + '"}';
            } else {
                var symbol = elem.parents('.download_btn').data('url').indexOf('?') == -1 ? '?' : '&';
                url = elem.parents('.download_btn').data('url') + symbol + 'e=';
                var data = {
                    format: f,
                    attachment: true
                };
                if (f == 'csv') {
                    data.encoding = 'cp1251';
                    data.columnTitle = true;
                }
                url += JSON.stringify(data);
            }
            window.open(url, '');
            elem.parents('.download_btn').removeClass('active');
        },
        initShareBtns: function() {
            var title = $('#dataset_title').text();
            var url = window.location.origin + window.location.pathname;
            var href;
            $('.dataset_share_btn').each(function(i,e) {
                href = $(e).attr('href').replace(/%title%/g, title).replace(/%url%/g, url);
                $(e).attr('href', href);
            });
        },
        showPopup: function(sel) {
            $('.popup_box').removeClass('active');
            $('#popup_wrapper').addClass('active');
            $(sel).find(".captWrapper").html("<img src='/feedback/captcha?"+(new Date()-1)+"'/>")
            setTimeout(function() {
                $(sel).addClass('active');
            }, 100);

            $('body').addClass('popup_opened');
        },
        hidePopup: function() {
            $('.popup_box').removeClass('active');
            setTimeout(function() {
                $('#popup_wrapper').removeClass('active');
                $('#popup_wrapper').find(".captWrapper").html("")
                $('body').removeClass('popup_opened');
            }, 150);
        },
        switchTab: function(elem, params) {
            var tar = elem.data('tab');
            var cont = elem.parents().data('container');
            $(cont).removeClass('active');
            $(tar).addClass('active');
            elem.addClass('active').siblings().removeClass('active');
            if (elem.hasClass('build_table')) {
                Act.changeHash('tab', 'build_table');
                //Act.getDatasetMapData();
                Act.buildDatasetTable();
                Act.getDatasetMapData();
                if (Data.myMap) Data.myMap.destroy();
                $('body').removeClass('disabled_fixedTable');
            }
            if (elem.hasClass('build_passport')) {
                Act.changeHash('tab', 'build_passport');
                //Act.getDatasetMapData();
                //if (typeof TableVar != 'undefined') TableVar.destroy(true);
                Act.getDatasetMapData();
                if (Data.myMap) Data.myMap.destroy();
                $('body').addClass('disabled_fixedTable');
            }
            if (elem.hasClass('build_map')) {
                Act.changeHash('tab', 'build_map');
                //if (typeof TableVar != 'undefined') TableVar.destroy(true);
                if (typeof Data.geo_fields == 'undefined') {
                    Act.getDatasetMapData(function() {
                        Act.initMap(true);
                    });
                } else Act.initMap(true);
                $('body').addClass('disabled_fixedTable');
            }
            if (params) {
                Act.changeHash(params.name, params.value);
            }
            if (window.scrollY > $('.tabs_wrapper').offset()['top']) {
                $(window).scrollTop($('#dataset_title').offset()['top']);
            }
        },
        alertAjaxError: function (a,b,c, text) {
            // alert(text+': '+c);
            console.error(a,b,c, text);
        },
        selectCategory: function(elem) {
            var id = '"' + elem.data('cat') + '"';
            Act.changeCategory($('.filter_aside_block[data-cat=\'' + id + '\']'));
        },
        changeCategory: function(elem) {
            console.log(elem);
            elem.addClass('active').siblings().removeClass('active');
            window.location.hash = elem.data('cat') ? elem.text() : '';
            if ($('#stats_wrapper').length)
                Act.reloadDatasetsStat();
            else if ($('#search_wrapper').length)
                Act.initSearch();
            else
                Act.reloadDatasets();
        },
        initFiltersScroll: function() {
            var start = $('#menu').height();
            var elem = $('.filters_aside');
            var offsTop = elem.offset().top;
            var leftEl = $('.data_content');
            var offsLeft = parseInt(leftEl.css('margin-left')) + leftEl.width() + leftEl.offset().left;
            $(window).on('resize load', function() {
                offsLeft = parseInt(leftEl.css('margin-left')) + leftEl.width() + leftEl.offset().left;
                elem.css('left', offsLeft);
            });
            $(window).on('scroll', function() {
                var scr = window.scrollY;
                if (scr > start) {
                    elem.addClass('fixed').css({
                        top: offsTop - start,
                        left: offsLeft
                    });
                } else {
                    elem.removeClass('fixed');
                }
            });
        },
        buildPaginator: function() {
            var m = parseInt($('#datasets_count').val());
            var l = parseInt($('#datasets_limit').val());
            var p = Math.ceil(m/l);
            $('#paginator').html('');
            if (p <= 1) return;
            for (var i = 1; i <= p; i++) {
                var first = i == 1 ? 'active' : '';
                $('#paginator').append('<div class="paginator_page ' + first + '">' + i + '</div>');
            }
        },
        reloadDatasets: function() {
            $('.show_more_datasets span').text($('#datasets_limit').val());
            var data = {};
            data.l = parseInt($('#datasets_limit').val());
            data.s = $('.paginator_page.active').index() * data.l;
            $('#paginator').show();
            if ($('.filter_aside_block.active').data('cat')) {
                data.f = '{"categories":"' + $('.filter_aside_block.active').data('cat').replace(/"/g, '') + '"}';
                data.s = 0;
                data.l = 0;
                $('#paginator').hide();
            }
            if ($('#datasets_sort').val()) {
                var obj = {};
                obj[$('#datasets_sort').val()] = $('#sort_type').hasClass('asc') ? 1 : -1;
                data.o = JSON.stringify(obj);
                Act.buildDatasetsList(data, true);
            } else {
                Act.buildDatasetsListByUsage(data, true);
            }

        },
        initSearch: function() {
            var word = decodeURIComponent(window.location.pathname.substr(window.location.pathname.lastIndexOf('/') + 1));
            if (!word) {
                $('#search_wrapper').html('<div class="search_empty">Введен пустой запрос</div>');
                return;
            }
            $('.search_field').val(word);
            var d = {
                "$text" : word
            };
            if ($('.filter_aside_block.active').data('cat'))
                d.categories = $('.filter_aside_block.active').data('cat').replace(/"/g, '');
            var data = {
                f: JSON.stringify(d)
            };
            $.ajax({
                url: '/v1',
                data: data,
                type: 'get',
                success: function(sets) {
                    var data = sets.data;
                    if (!data.length) {
                        $('#search_wrapper').html('<div class="search_empty">Ничего не найдено</div>');
                        return;
                    }
                    var tmpl = $('#dataset_block_template').html();
                    var html = '';
                    for (var d in data) {
                        var cats = '';
                        var desc = '';
                        for (var c in data[d].categories) {
                            cats += '<div class="dataset_cat" data-cat="' + data[d].categories[c] + '">' + Data.categories[data[d].categories[c]] + '</div>';
                        }
                        if (data[d].description) {
                            desc = '<div class="dataset_info"><div>' + data[d].description + '</div></div>';
                        }
                        var url = '/item/dataset/' + data[d]._id;
                        if (data[d].entityFullname) url = '/opendata/' + data[d].entityFullname;
                        html += tmpl.replace(/%id%/g, data[d]._id).replace(/%title%/g, data[d].title).replace(/%categories%/g, cats).replace(/%info%/g, desc).replace(/%url%/g, url);
                    }
                    $('#search_wrapper').html(html);
                    Act.initDownloadButtons();
                },
                error: function(a, b, c) {
                    Act.alertAjaxError(a,b,c,'Не удалось получить набор схем');
                }
            });
        },
        buildDatasetsList: function(data, reload) {
            data.sel = 'entityFullname categories title description title masterSetLink';
            $.ajax({
                url: '/v1',
                data: data,
                type: 'get',
                success: function(sets) {
                    var data = sets.data;
                    var tmpl = $('#dataset_block_template').html();
                    var html = '';
                    for (var d in data) {
                        var cats = '';
                        var desc = '';
                        var btn = $('#download_btn_template').html();
                        var btn_html = '';
                        var url = '/item/dataset/' + data[d]._id;
                        for (var c in data[d].categories) {
                            cats += '<div class="dataset_cat" data-cat="' + data[d].categories[c] + '">' + Data.categories[data[d].categories[c]] + '</div>';
                        }
                        if (data[d].description) {
                            desc = '<div class="dataset_info"><div>' + data[d].description + '</div></div>';
                        }
                        if (data[d].masterSetLink) {
                            btn = $('#open_btn_template').html();
                            btn_html += btn.replace(/%link_url%/g, data[d].masterSetLink);
                        } else {
                            btn_html += btn.replace(/%id%/g, data[d]._id);
                        }
                        if (data[d].entityFullname) url = '/opendata/' + data[d].entityFullname;
                        html += tmpl.replace(/%id%/g, data[d]._id).replace(/%title%/g, data[d].title).replace(/%categories%/g, cats).replace(/%info%/g, desc).replace(/%url%/g, url).replace(/%action_btn%/g, btn_html);
                    }
                    if (reload)
                        $('#datasets_wrapper').html(html);
                    else
                        $('#datasets_wrapper').append(html);
                    Act.initDownloadButtons();
                },
                error: function(a, b, c) {
                    Act.alertAjaxError(a,b,c,'Не удалось получить набор схем');
                }
            });
        },
        buildDatasetsListByUsage: function(data, reload) {
            data.o = '{"totals.all":"' + ($('#sort_type').hasClass('asc') ? 1 : -1) + '"}';
            data.p = 'odSet';
            $.ajax({
                url: '/v1/usage',
                data: data,
                type: 'get',
                success: function(data) {
                    var sets = data.data;
                    var tmpl = $('#dataset_block_template').html();
                    var html = '';
                    for (var d in sets) {
                        var cats = '';
                        var desc = '';
                        var btn = $('#download_btn_template').html();
                        var btn_html = '';
                        var data = sets[d].odSet;
                        var url = '/item/dataset/' + data._id;
                        for (var c in data.categories) {
                            cats += '<div class="dataset_cat" data-cat="' + data.categories[c] + '">' + Data.categories[data.categories[c]] + '</div>';
                        }
                        if (data.description) {
                            desc = '<div class="dataset_info"><div>' + data.description + '</div></div>';
                        }
                        if (data.masterSetLink) {
                            btn = $('#open_btn_template').html();
                            btn_html += btn.replace(/%link_url%/g, data.masterSetLink);
                        } else {
                            btn_html += btn.replace(/%id%/g, data._id);
                        }
                        if (data.entityFullname) url = '/opendata/' + data.entityFullname;
                        html += tmpl.replace(/%id%/g, data._id).replace(/%title%/g, data.title).replace(/%categories%/g, cats).replace(/%info%/g, desc).replace(/%url%/g, url).replace(/%action_btn%/g, btn_html);
                    }
                    if (reload)
                        $('#datasets_wrapper').html(html);
                    else
                        $('#datasets_wrapper').append(html);
                    Act.initDownloadButtons();
                },
                error: function(a, b, c) {
                    Act.alertAjaxError(a,b,c,'Не удалось получить набор схем');
                }
            });
        },
        reloadDatasetsStat: function(elem, isAdd) {
            var order = 1;
            if (!elem) {
                if ($('.sort_btn.asc').length) elem =  $('.sort_btn.asc');
                else {
                    elem =  $('.sort_btn.desc');
                    order = -1;
                }
            } else {
                if (elem.hasClass('asc')) {
                    elem.removeClass('asc').addClass('desc');
                    order = -1;
                } else if (elem.hasClass('desc')) {
                    elem.removeClass('desc').addClass('asc');
                } else {
                    elem.addClass(elem.data('def'));
                    if (elem.data('def') == 'desc') order = -1;
                }
                elem.siblings('.sort_btn').removeClass('asc desc');
            }
            var type = elem.data('type');
            var url = '/v1';
            var data = {};
            data.l = $('#datasets_limit').val();
            data.s = $('.paginator_page.active').length ? $('.paginator_page.active').index() : 0 * $('#datasets_limit').val();
            data.j = '{"usage":{"entity":"ODUsageTotal","link":"odSet","sel":"totals"},"mark":{"entity":"ODSetMark","link":"odSet","sel":"marksAvg"}}';
            data.sel = 'title entityName categories description entityFullname';
            $('#paginator').show();
            if ($('.filter_aside_block.active').data('cat')) {
                data.f = '{"categories":"' + $('.filter_aside_block.active').data('cat').replace(/"/g, '') + '"}';
                data.l = 0;
                data.s = 0;
                $('#paginator').hide();
            }
            switch (type) {
                case 'views':
                    data.o = '{"usage.totals.read": ' + order + '}';
                    break;
                case 'downloads':
                    data.o = '{"usage.totals.download": ' + order + '}';
                    break;
                case 'rating':
                    data.o = '{"mark.marksAvg": ' + order + '}';
                    break;
                default: //name
                    data.o = '{"title": ' + order + '}';
                    break;
            }
            $.ajax({
                url: url,
                data: data,
                success: function(d) {
                    console.log(d);
                    var html = '';
                    var tmpl = $('#dataset_block_template').html();
                    for (var i in d.data) {
                        var cats = '';
                        var desc = '';
                        var s = d.data[i].value;
                        var mark = s.mark ? s.mark.marksAvg.toFixed(1) : '0';
                        for (var c in s.data.categories) {
                            cats += '<div class="dataset_cat" data-cat="' + s.data.categories[c] + '">' + Data.categories[s.data.categories[c]] + '</div>';
                        }
                        if (s.data.description) {
                            desc = '<div class="dataset_info"><div>' + s.data.description + '</div></div>';
                        }
                        var url = '/item/dataset/' + s.data._id;
                        if (s.data.entityFullname) url = '/opendata/' + s.data.entityFullname;
                        html += tmpl.replace(/%id%/g, d.data[i]._id).replace(/%title%/g, s.data.title).replace(/%views%/g, s.usage.totals.read).replace(/%downloads%/g, s.usage.totals.download).replace(/%rating%/g, mark).replace(/%categories%/g, cats).replace(/%info%/g, desc).replace(/%url%/g, url);
                    }
                    $('#stats_wrapper').html(html);
                    $('#datasets_skip').val(data.s + data.l);

                },
                error: function(a,b,c) {
                    Act.alertAjaxError(a,b,c,'Не удалось получить статистику по наборам');
                }
            });

        },
        getDatasetRating: function() {
            var id = $('#dataset_id').val();
            var data = {
                f: JSON.stringify({odSet: id}),
                timestamp:(new Date()-0)
            };
            $.ajax({
                url: '/feedback/mark/',
                data: data,
                success: function(data) {
                    var d = data.data[0];
                    if (!d) return;
                    if (d.marksAvg > 5) d.marksAvg = 5;
                    d.marksAvg = Math.round(d.marksAvg*2)/2;
                    var w = ((d.marksAvg/5) * 100) + '%';
                    Data.rating_width = w;
                    $('#dataset_rating, .user_rating div').css('width', w);
                    $('#dataset_rate').text(d.marksAvg.toFixed(1));
                    $('#dataset_voices').text(d.marksCnt);
                },
                error: function(a,b,c) {
                    console.log(a,b,c);
                }
            });
        },
        getDataset: function() {
            if (!(typeof TableVar == 'undefined')) return;
            var id = $('#dataset_id').val();
            //Заполнение селектов схемы/версии
            var schemaEl = $("#schema_select");
            $.get("/v1/$schemas", {f:JSON.stringify({"dataset":id}), sel:"version dataset", o: "dataset"})
                .done(function(resp){
                    schemaEl.empty().removeAttr('disabled');
                    if (resp.data && resp.data.length) {
                        var inc = 1;
                        resp.data.forEach(function(i){
                            var sel = '';
                            if (inc == resp.data.length) sel = 'selected';
                            schemaEl.append($("<option " + sel + "></option>").attr("value", i._id).text('Версия '+i.version));
                            inc++;
                        });
                    }
                    schemaEl.trigger('change');
                    Act.buildDatasetVersions();
                });

        },
        buildDatasetVersions: function() {
            var hash = Act.changeHash('schema');
            if (hash && $("#schema_select").find('option[value="' + hash.schema + '"]').length) {
                $("#schema_select").val(hash);
            }
            var schId = $("#schema_select").val();
            var versEl = $("#version_select");
            $.get("/v1/$versions", {f:JSON.stringify({"odSchema":schId}), sel:"odSchema version", o:JSON.stringify({"snapshotTime":-1}) })
                .done(function(resp) {
                    versEl.empty().removeAttr('disabled');
                    if (resp.data && resp.data.length) {
                        resp.data.forEach(function(i, ind){
                            if (ind == 0)
                                versEl.append($("<option></option>").attr({"value" : i._id, selected: 'selected'}).text('Версия '+i.version));
                            else
                                versEl.append($("<option></option>").attr("value", i._id).text('Версия '+i.version));
                        });
                        versEl.trigger('change');
                        var odSet = $('#dataset_id').val();
                        var schemaId = $("#schema_select").val();
                        var schemaUrl = "/v1/$schemas";
                        $.ajax({
                            url: schemaUrl,
                            data: {
                                f: JSON.stringify({"dataset": odSet})
                            },
                            dataType: 'json',
                            method: 'GET',
                            headers: {"Accept": "application/json"},
                            error: function (jqXHR, textStatus, errorThrown) {
                                // alert("Не удалось удалить "+event.data.description+". Статус операции:"+textStatus);
                                console.error("Can't get schema of data ", textStatus, url);
                            },
                            success: function (data, status) {
                                Data.schema = data.data[0];
                            }
                        });
                    }
                });
        },
        buildDatasetTable: function() {
            //Построение таблицы
            var notSelectedText = 'Не выбрано';
            var isErrorsOnly=false;
            var Types = require("types.js");
            var odSet = $('#dataset_id').val();
            var hash = Act.changeHash('');
            var schema_select = $("#schema_select");
            if (hash.schema && schema_select.find('option[value="' + hash.schema + '"]').length) {
                schema_select.val(hash.schema);
                if (hash.version) $("#version_select").val(hash.version);
            } else {
                schema_select.val(schema_select.find('option').first().val());
            }

            var schemaId = $("#schema_select").val();
            var odSetVersions = $("#version_select").val();
            clearTimeout(Data.table_timeout);
            if (!schemaId || !odSetVersions || !Data.schema) {
                Data.table_timeout = setTimeout(function() {
                    Act.buildDatasetTable();
                }, 200);
                return;
            }
            var schemaUrl = "/v1/$schemas";
            var tableElement = $('#dataset_table');
            //var TableVar;
            var options =  {
                ajax:{},
                destroy: true,
                processing: true,
                serverSide: true,
                bFilter: true,
                searchDelay: 1000,
                rowId: '_id',
                language:{
                    "processing": "Подождите...",
                    "search": "Поиск:",
                    "lengthMenu": "Показать _MENU_ записей",
                    "info": "Записи с _START_ до _END_ из _TOTAL_ записей",
                    "infoEmpty": "Записи с 0 до 0 из 0 записей",
                    "infoFiltered": "(отфильтровано из _MAX_ записей)",
                    "infoPostFix": "",
                    "loadingRecords": "Загрузка записей...",
                    "zeroRecords": "Записи отсутствуют.",
                    "emptyTable": "В таблице отсутствуют данные",
                    "paginate": {
                        "first": "Первая",
                        "previous": "Предыдущая",
                        "next": "Следующая",
                        "last": "Последняя"
                    },
                    "aria": {
                        "sortAscending": ": активировать для сортировки столбца по возрастанию",
                        "sortDescending": ": активировать для сортировки столбца по убыванию"
                    }
                },
                "createdRow": function ( row, data, index ) {
                    var isFirst=(data.odSetVersions.indexOf(odSetVersions)==0)
                    var isError=(data.status!=0);
                    var nativeId=data.nativeId;
                    if (isError)
                        $(row).addClass('errorLine');
                    if (isFirst)
                        $(row).addClass('newline');
                    if (nativeId)
                        $(row).attr('data-nativeid', nativeId);
                }
            };
            function initTableElement(elem) {
                if (window.location.hash.length > 1) {
                    var obj = JSON.parse(decodeURIComponent(window.location.hash.substr(1)));
                    if (obj.row) {
                        callRowCard(obj.row.id, obj.row.nativeId);
                        rowData = {nativeId: obj.row.nativeId };
                    }
                }

                elem.on('click', 'td', function (event) {
                    if ($(event.target).hasClass('map_icon')) {
                        var el = $(event.target);
                        var lat = el.data('lat');
                        var lng = el.data('lng');
                        localStorage.setItem('icon_title', $(this).parents('tr').find('.native_name').text());
                        Act.switchTab($('.build_map'), {name: 'map', value: {'lat' : lat, 'lng' : lng}});
                    } else {
                        var disabled=tableElement.attr("data-disabled");
                        if (disabled-0) return;

                        var tr =  $(this).closest("tr");
                        tableElement.find('tr').removeClass('active');
                        $('#sendErrors').html('');
                        tr.addClass('active').siblings().removeClass('active');
                        var mode='analizer';
                        var id=$(tr).attr('id');
                        var nativeId= $(tr).attr('data-nativeid');
                        rowData = elem.DataTable().row( tr ).data();
                        event.preventDefault();
                        callRowCard(id, nativeId);
                    }
                });

                function callRowCard(id, nativeId) {
                    Data.currentRow = {
                        id: id,
                        nativeId: nativeId
                    };
                    if (id) {
                        var ver = $('#version_select').val();
                        var url="/v1/schema/@"+schemaId+"/@/"+nativeId;
                        var reqData={
                            f:JSON.stringify({inactivated:{$exists:false}}),
                            p:"odSetVersions odSchema",
                            o:"modified"
                        };
                        $.ajax({
                            url:url,
                            // dataType:'json',
                            data:reqData,
                            method:'GET',
                            headers:{"Accept":"application/json"},
                            error:function(jqXHR, textStatus, errorThrown) {
                                alert("Не удалось получить данные. Статус операции:"+textStatus);
                                console.error("Can't get row history data", textStatus, url);
                            },
                            success: function(data, status) {
                                renderHistoryData(data);

                                var d = $('#detail');
                                var v = $('#versions_wrapper');
                                var vh = v.height() - 48;
                                var scrollScreens = Math.ceil(d.height() / vh);
                                if (scrollScreens < 2) {
                                    $('#versions_scroll_up, #versions_scroll_down').hide();
                                } else {
                                    $('#versions_scroll_up, #versions_scroll_down').show();
                                }

                                var obj = {};
                                if (window.location.hash.length > 1)
                                    obj = JSON.parse(window.location.hash.substr(1));
                                obj.row = {
                                    nativeId: nativeId,
                                    id: id
                                };
                                window.location.hash = JSON.stringify(obj);
                            }
                        })
                    }
                }
                //Получаем информацию по связям в выбраном наборе
                $.ajax({
                    url:"/v1/schema/@"+schemaId+"/@"+odSetVersions+"/$links",
                    dataType:'json',
                    data:{p:"schema"},
                    method:'GET',
                    headers:{"Accept":"application/json"},
                    error:function(jqXHR, textStatus, errorThrown) {
                        alert("Не удалось получить связи для схемы. Статус операции:"+textStatus);
                        console.error("Can't get links for schema", textStatus, url);
                    },
                    success: function(data, status) {
                        if (data.status != 200) {
                            if (data.error.message) alert(data.error.message);
                            else alert("Не удалось получить связи для схемы.");
                            console.log(data);
                        }
                        var schemasBlock=$("#linksSchemas");
                        var da = data.data;
                        if (!da.length) {
                            Data.links = [];
                            $('.show_links').hide();
                            return;
                        }
                        Data.links = da;
                        var links_raw = da;
                        var links = [];
                        var schemaId = $("#schema_select").val();
                        Data.links_path = [];
                        for (var l in links_raw) {
                            var field = links_raw[l];
                            Data.links_path.push(field.field.path);
                            /* for (var f in field.links) {
                             Data.links_path.push(field.links[f].field.path);
                             } */
                        }
                    }
                });
            }
            initTableElement(tableElement);
            function renderHistoryData(responseData) {
                var diffBlock=$("#detail");
                diffBlock.empty();
                var rows=responseData.data;
                var versions=[];
                rows.forEach(function(nativeEntity, j){
                    nativeEntity.odSetVersions.forEach(function(aVersion, i){
                        var errors={};
                        if ($.isArray(nativeEntity.errorFields) ) {
                            nativeEntity.errorFields.forEach(function(e){
                                errors[e.dataPath.substr(1)]=e.message;
                            })
                        };
                        versions.push({time:aVersion.snapshotTime, version:aVersion.version, _id:nativeEntity._id, data:nativeEntity.data, version_id:aVersion._id, errors:errors });
                    });
                });
                versions=versions.sort(function(a,b){return (a.time>b.time?-1: a.time<b.time?1:0) });
                versions.forEach(function(a, i){
                    diffBlock.append('<div '+(i==0?'class="selected"':'')+'data-index="'+i+'" data-rowId="'+a._id+'" data-version="' + a.version_id + '"><span class="diffBlockVersion">версия '+a.version+'</span><span class="diffBlockDate">'+moment(a.time).format(Data.datetaime_format)+'</span></div>');
                });
                function updateDiff(index) {
                    var oneRowData=versions[index];
                    var prevData;
                    if (index<versions.length-1)
                        prevData=versions[index+1].data;

                    showDiff(oneRowData.data, prevData, oneRowData.errors);
                    Data.card_data = oneRowData.data;
                };
                diffBlock.off("click touchend");
                diffBlock.on("click touchend", "div", function(e) {

                    var disabled=tableElement.attr("data-disabled");
                    if (disabled-0) return;

                    diffBlock.find("div").removeClass("selected");
                    var index=$(this).data("index")-0;
                    updateDiff(index);
                    $(this).addClass("selected");
                    var durl = '/v1/@' + odSet + '/@' + $(this).data("version") + '/' + rowData.nativeId;
                    $('.history_action_bar .download_btn').attr('data-url',durl);
                });

                updateDiff(0);
                $('#detail > div[data-version="' + $('#version_select').val() + '"]').click();
                var durl = '/v1/@' + odSet + '/@' + odSetVersions + '/' + rowData.nativeId;
                $('.history_action_bar .download_btn').attr('data-url',durl);
                $("#historyScrollWrapper").mCustomScrollbar();
                $('.history_errors').removeClass('show').find('.visible span').html('&nbsp;0 ошибок');
                $('#historyContainer').addClass('active');
            }
            var getPath = function(obj, path) {
                if (window.mpath)
                    return mpath.get(path, obj)

                var parts = path.split('.');
                while (parts.length && (obj = obj[parts.shift()] ) );
                return obj;
            }

            function showDiff(a, b, errors, c, d) {

                var container= typeof c == 'undefined' ? $("div#diff") : c;
                var schema = typeof d == 'undefined' ? Data.jsonSchema : d;
                b = b || {};
                var diffs=DeepDiff.diff(b, a) || [];

                function difStatus(path) {
                    var sp=path.split(".");
                    var d=diffs.filter(function(d){
                        var p=d.path;
                        if (!p) return false;
                        if (p.length!=sp.length)
                            return false;
                        for(var i=0;i<p.length;i++)
                            if (p[i]!=sp[i])
                                return false;
                        return true;
                    });
                    return d.length?d[0]:false;
                }
                function _emptyVal(val, fldType) {
                    if (fldType)
                        return fldType.toHTML(val)
                    else
                        return (val?val:"пусто");
                }
                function item(obj, value, key, path) {
                    if (!obj)
                        return {value:"", isEmpty:true};
                    if ($.isArray(obj.type) ) {
                        obj.type=obj.type.filter(function(a){ return (a!="null"); });
                        obj.type=obj.type.length?obj.type[0]:"null";
                    }

                    var itemPath=path.substr(1);
                    var isErrors=false;//(itemPath in errors);
                    var errClass=isErrors?" errorLine":"";
                    if (obj.type=="array" && obj.items)  {
                        var diff = difStatus(path.substr(1));
                        var cl="";
                        var addon="";
                        var fldType = Types.factory(obj, path.substr(1));
                        if (diff) {
                            if (diff.kind=="N")
                                cl="inserted";
                            else
                            if (diff.kind=="A" ||  diff.kind=="E" || diff.kind=="D") {
                                addon="<div class='deleted'>"+_emptyVal(diff.lhs, fldType)+"</div>";
                                cl=diff.kind=="E"?"modified":"deleted";
                            }
                        }
                        var res=[];
                        if (!fldType) {
                            var subs=[];
                            var isAllEmpty=true;
                            var sub={isEmpty:false};
                            for(var i=0; !sub.isEmpty && i<MAX_ARRAY_ITEMS; i++) {
                                var sub=item(obj.items, value, i, path+"."+i);
                                isAllEmpty = isAllEmpty && sub.isEmpty;
                                if (!sub.isEmpty)
                                    subs.push(sub.value);
                            }
                            res.push("<label class='"+cl+(isAllEmpty?" empty":"")+"'> "+(obj.title?obj.title:"")+"</label>"+addon);
                            res.push("<ol class='"+cl+(isAllEmpty?" empty":"")+"'><li>");
                            res.push(subs.join("</li>\n<li>"));
                            res.push("</li></ol>");
                            if (value['general'][key] && value['general'][key].length > MAX_ARRAY_ITEMS) {
                                res.push("<div class='hiddenElems'>Список содержит еще " + (value['general'][key].length - MAX_ARRAY_ITEMS) +  " элементов, доступных в API</div>");
                            }
                            return {value:res.join("\n"), isEmpty:isAllEmpty};
                        } else {
                            var val= getPath(value, itemPath) || "";
                            res.push("<div class='"+cl+(!val?" empty":"")+errClass+"' a='2' ><input type='checkbox' data-path='"+itemPath+"'"+(isErrors?" checked ":"")+"><label>"+(obj.title || fldType.title)+"</label></div>"+addon);
                            res.push(_emptyVal(val, fldType));
                            return {value:res.join("\n"), isEmpty:!val};
                        }

                    }
                    else

                    if (obj.type=="object" || (!obj.type && obj.properties) )  {
                        var diff = difStatus(path.substr(1));
                        var cl="";
                        var addon="";
                        var fldType = Types.factory(obj, path.substr(1));
                        if (diff) {
                            if (diff.kind=="N")
                                cl="inserted";
                            else
                            if (diff.kind=="A" ||  diff.kind=="E" || diff.kind=="D") {
                                addon="<div class='deleted'>"+_emptyVal(diff.lhs, fldType)+"</div>";
                                cl=diff.kind=="E"?"modified":"deleted";
                            }
                        }
                        var res=[];

                        if (!fldType && obj.properties) {

                            var subs=[];
                            var isAllEmpty=true;
                            for(var p in obj.properties) {
                                var sub=item(obj.properties[p], value, p, path+"."+p);
                                isAllEmpty = isAllEmpty && sub.isEmpty;
                                subs.push(sub.value);
                            }
                            if (obj.title)
                                res.push("<label class='"+cl+(isAllEmpty?" empty":"")+"'>"+obj.title+"</label>");
                            res.push(addon);
                            res.push("<ul class='"+cl+(isAllEmpty?" empty":"")+"'><li>");
                            res.push(subs.join("</li>\n<li>"));
                            res.push("</li></ul>");
                            return {value:res.join("\n"), isEmpty:isAllEmpty};
                        } else {
                            var val= getPath(value, itemPath) || "";
                            res.push("<div class='"+cl+(!val?" empty":"")+errClass+"' a='2' ><input type='checkbox' data-path='"+itemPath+"'"+(isErrors?" checked ":"")+"><label>"+(obj.title || fldType.title)+"</label></div>"+addon);
                            res.push(_emptyVal(val, fldType));
                            return {value:res.join("\n"), isEmpty:!val};
                        }

                    }
                    else {

                        var val= getPath(value, itemPath) || "";
                        var diff = difStatus(itemPath);
                        var cl="";
                        var addon="";
                        var fldType = Types.factory(obj, itemPath);
                        if (diff) {
                            if (diff.kind=="A" || diff.kind=="N")
                                cl="inserted";
                            else
                            if (diff.kind=="E" || diff.kind=="D") {
                                addon="<div class='deleted'>"+_emptyVal(diff.lhs, fldType)+"</div>";
                                cl=diff.kind=="E"?"modified":"deleted";
                            }
                        }

                        var links_class = '';
                        if ($.inArray(itemPath, Data.links_path) != -1) {
                            links_class = 'link_enable';
                        }
                        var label=($.isNumeric(key)?"":(obj.title || key));
                        var htm="<div class='"+cl+(!val?" empty":"")+errClass+"'><input type='checkbox' data-path='"+itemPath+"'"+(isErrors?" checked ":"")+">"+
                            (label?"<label class='" + links_class + "'> "+label+"</label>":"")+
                            addon+"<div a='3'>"+_emptyVal(val, fldType)+"</div></div>";
                        return  { isEmpty:!val, value:htm};
                    }

                }
                container.html("<div class='diffs'>"+item(schema, a,  "", "").value+"</div>" ); // +"<pre>"+JSON.stringify(diffs)+"</pre>"

            }

            function _init(tableElement, options) {
                // tableElement.DataTable().destroy();
                if (typeof TableVar != 'undefined') {
                    TableVar.clear().draw();
                    TableVar.destroy(true);
                    $('.table_tab').append('<table id="dataset_table" cellpadding="0" cellspacing="0"></table>');
                    tableElement = $('#dataset_table');
                    initTableElement(tableElement);
                }
                TableVar = tableElement.DataTable(options);
                var timer;
                $('#table_search').keyup(function(){
                    if (typeof timer != 'undefined') clearTimeout(timer);
                    var _this = this;
                    $(_this).addClass('search');
                    timer = setTimeout(function(){
                        $('th input').attr('disabled', 'disabled');
                        TableVar.search($(_this).val()).draw();
                    }, 1000);
                });
                $('#table_length').on('change', function() {
                    TableVar.page.len($(this).val()).draw();
                    $(this).blur();
                });
                TableVar.ajax.reload();
                $(window).on('resize', function () {
                    TableVar.responsive.recalc();
                } );
                var offsElem = $('#dataset_table_wrapper');
                var Ooffs = offsElem.length ? offsElem.offset()['top'] : 0;
                var fixedH = $('#fixed_panel').height() + parseInt($('#fixed_panel').css('padding-top')) + parseInt($('#fixed_panel').css('padding-bottom'));
                function calcSideWindowH() {
                    if (!$('.build_table').hasClass('active')) return;
                    var scr = window.scrollY;
                    var h = window.innerHeight;
                    var head = $('#dataset_table th:first');
                    var hElem = head.height() + parseInt(head.css('padding-bottom')) + parseInt(head.css('padding-top'));
                    if (scr > Ooffs + hElem - 2*fixedH - 20) {
                        hElem = $('.fixedHeader-floating').height();
                        $('.slideElem').addClass('fixed').css({
                            height: h - hElem - fixedH,
                            top: hElem + fixedH
                        });
                        $('.sideWindow').css({
                            height: 'auto',
                            top: 0
                        });
                        $('#fixed_panel').addClass('active');
                    } else {
                        var offs = $('#dataset_table').offset()['top'] - $('.table_tab').offset()['top'];
                        $('.slideElem').removeClass('fixed').css({
                            height: '100%',
                            top: 0
                        });
                        $('.sideWindow').css({
                            height: scr + (h - (Ooffs + hElem)),
                            top: offs + hElem
                        });
                        $('#fixed_panel').removeClass('active');
                    }
                    var d = $('#detail');
                    var v = $('#versions_wrapper');
                    v.css('height', $("#historyScrollWrapper").height());
                    var vh = v.height() - 48;
                    var scrollScreens = Math.ceil(d.height() / vh);
                    if (scrollScreens < 2) {
                        $('#versions_scroll_up, #versions_scroll_down').hide();
                    } else {
                        $('#versions_scroll_up, #versions_scroll_down').show();
                    }
                }
                calcSideWindowH();
                $(window).on('scroll load resize', function() {
                    calcSideWindowH();
                });
            }
            $.ajax({
                url:schemaUrl,
                data: {
                    f:JSON.stringify({"dataset":odSet,"_id":schemaId})
                },
                dataType:'json',
                method:'GET',
                headers:{"Accept":"application/json"},
                error:function(jqXHR, textStatus, errorThrown) {
                    // alert("Не удалось удалить "+event.data.description+". Статус операции:"+textStatus);
                    console.error("Can't get schema of data ", textStatus, url);
                },
                success: function(data, status) {
                    odSchema = data.data[0];
                    Data.schema = odSchema;
                    jsonSchema = JSON.parse(odSchema.schemaText);
                    Data.jsonSchema = jsonSchema;
                    dataFields=Types.fieldsList(jsonSchema);
                    var tableFields=dataFields.filter(function(fld){ return fld.schema.table>0 });
                    tableFields=tableFields.sort(function(a,b){return a.schema.table>b.schema.table?1:b.schema.table>a.schema.table?-1:0});
                    //console.log(tableFields);
                    // var data=data.presentation;
                    options.autoWidth = false;
                    options.pageLength = 25;
                    var ua = navigator.userAgent.toLowerCase();
                    var isAndroid = ua.indexOf("android") > -1;
                    if (!isAndroid) {
                        options.fixedHeader = {};
                        options.fixedHeader.header = true;
                        options.fixedHeader.headerOffset = $('#fixed_panel').height() + parseInt($('#fixed_panel').css('padding-top')) + parseInt($('#fixed_panel').css('padding-bottom'));
                    }
                    options.aoColumns=[];
                    //options.scrollX = true;
                    //options.responsive = true;
                    options.language = {
                        "info": "Показаны с _START_ по _END_ из _TOTAL_ записи",
                        "infoFiltered": "(отфильтровано из _MAX_ записи)",
                        "zeroRecords": "Ничего не найдено",
                        "emptyTable": "Отсутствуют данные для отображения"
                    };

                    var filter = {odSetVersions:odSetVersions, odSchema:schemaId };
                    if (isErrorsOnly)
                        filter.status=2;

                    options.ajax.url = "/api/table/"+odSchema.collectionName+"/";
                    if (window.location.hash.length > 1) {
                        var obj = JSON.parse(decodeURIComponent(window.location.hash.substr(1)));
                        if (obj.link) {
                            $('.filtered_by, .remove_filter').show();
                            $('.filtered_by span').text(obj.link.field);
                            filter["data." + obj.link.path] = obj.link.val;
                        }
                    }
                    $('#map_filters input').each(function(i,e) {
                        if ($(e).val()) {
                            filter["data." + $(e).attr('name')] = $(e).val();
                        }
                    });
                    options.ajax.method= "POST";
                    options.ajax.data={f:JSON.stringify(filter)}; // put number fields into chartPropsSelect
                    options.drawCallback = function( settings ) {
                        Errors = {};
                        $('.history_errors').removeClass('show').find('.visible span').html('&nbsp;0 ошибок');
                        $('th input, #table_search').removeClass('search').removeAttr('disabled');
                    };
                    var numericFields=[];

                    numericFields.push("<option disabled selected>" + notSelectedText + "</option>");
                    dataFields.forEach(function(fld){
                        if (fld.schema.logicalType=="Number")
                            numericFields.push("<option value='"+fld.path+"'>"+fld.title+"</option>")
                    });

                    for(var i=0; i<tableFields.length; i++) {
                        var fld=tableFields[i];
                        var key = "data."+fld.path;
                        var aType = fld.schema.logicalType || "String";
                        console.log(aType);
                        var orderable = !!fld.indexable && !(aType == 'GeoJSON' || aType == 'MapPosition');
                        var colOptions={ data:key,
                            title: fld.title,
                            // visible:!listOptions.hidden,
                            type:aType,
                            defaultContent: "",
                            logicalType:fld,
                            name:key,
                            orderable: orderable
                        };
                        if (fld.path == Data.schema.nativeListField) {
                            colOptions.class = 'native_name';
                        }



                        colOptions.render = function ( data, type, full, meta )  {
                            var logicalType = meta.settings.aoColumns[meta.col].logicalType;
                            if (!logicalType) return "";
                            var val = "";
                            if (logicalType.path && data) {
                                if (typeof data== "object") {
                                    if (typeof logicalType.convertCoordinates == "function") {
                                        var coords = logicalType.convertCoordinates(data);
                                        val = '<div class="map_icon" data-lat="' + coords[0] + '" data-lng="' + coords[1] + '"></div>';
                                    } else if (logicalType.path in data)
                                        val = data[logicalType.path];
                                    else
                                    if (window.mpath)
                                        val = mpath.get(logicalType.path, data)
                                    else {
                                        console.warn("MPATH library not loaded");
                                    }
                                } else val=data;
                            } else val=data;
                            if (val && logicalType.toString(coords))
                                val = logicalType.toString(val);
                            return val;
                        }
                        options.aoColumns.push(colOptions);
                    }
                    // start adding filters
                    var filtersOpened = false;
                    options.initComplete = function () {
                        var table = $(this).DataTable();
                        this.api().columns().every( function () {
                            var column = this;
                            var selected=column.search();
                            var settings=column.settings()[0].aoColumns[column.index()];
                            var fld=settings.logicalType;
                            var container=$(".main_filters");
                            if (selected && !filtersOpened) {
                                $('.main_filters, .main_filters_show').toggleClass('active');
                                filtersOpened = true;
                            }

                            container=container.length?container:column.header();

                            if (fld && fld.indexable) {
                                if ($(".main_filters").length) {
                                    container=$("<div></div>").appendTo( container );
                                    $("<div class='title'>"+settings.title+"</div>").appendTo( container );
                                    container=$("<div class='filter'></div>").appendTo( container );
                                }
                                else $("<p/>").appendTo( container );
                                /*
                                 TODO: different filters depends of field type
                                 if (fld.TYPE=='') {

                                 }
                                 */
                                var timer;
                                var fil_val = false;
                                var inp = $('#map_filters input[name="' + settings.data.replace('data.','') + '"]');
                                if (inp.val()) {
                                    fil_val = inp.val();
                                }
                                var input = $('<div><input  name="'+settings.data+'" value="'+(column.search() || fil_val || '') +'"/></div>')
                                    .appendTo( container )
                                    .on('touchend', function(e) {
                                        $(this).find('input').focus();
                                    })
                                    .on( 'keyup', 'input', function () {
                                        $(this).addClass('search').parents('th').siblings().find('input').attr('disabled', 'disabled');
                                        var disabled=tableElement.attr("data-disabled");
                                        if (disabled-0) return;
                                        if (timer != 'undefined') {
                                            clearTimeout(timer);
                                            timer=null;
                                        }
                                        var that='input[name="' + $(this).attr('name') + '"]';
                                        timer= setTimeout(function(){
                                            timer=null;
                                            column.search($(that).val() || '', true, false );
                                            table.ajax.reload(function() {
                                                $(that).focus();
                                            });
                                            var filter = $('#map_filters input[name="' + $(that).attr('name').replace('data.','') + '"]');
                                            filter.val($(that).val());

                                        }, 1000);
                                    } ).on( 'click touchend', function (e) {
                                        e.preventDefault();
                                        e.stopPropagation();
                                    } );
                            }
                        } );
                    };
                    _init(tableElement, options);
                    $('.dataTablesOptions').show();
                }

            });
        },
        openRowLinks: function(elem) {
            var p = elem.siblings('input').data('path');
            var v = elem.siblings('div').text();
            var sid = Data.schema._id;
            var native_name = mpath.get(Data.schema.nativeListField  || Data.schema.nativeId || "_id", Data.card_data);
            $('#rowLinksRowName').text(elem.text());
            var html = '';
            var r_html = '';
            var tmpl = $('#row_links_template').html();
            var block_tmpl = $('#schema_links_block_template').html();
            var row_tmpl = $('#card_link_row_template').html();
            var b_html = '', r_html;
            var links_raw = Data.links;
            var links = [];
            for (var l in links_raw) {
                var field = links_raw[l];
                if (field.field.path == p) {
                    links.push(links_raw[l]);
                }
                /* for (var f in field.links) {
                 if (field.links[f].field.path == p) {
                 links.push(links_raw[l]);
                 break;
                 }
                 } */
            }
            for (var l in links) {
                r_html = '';
                for (var r in links[l].links) {
                    var s = links[l].links[r].odSchema;
                    var d = moment(s.modified).format("DD-MM-YYYY");
                    var master = s.master ? 'master_schema' : '';
                    var params = {
                        tab: 'build_table',
                        link: {
                            path: links[l].links[r].field.path,
                            val: v,
                            field: native_name,

                        },
                        schema: links[l].links[r].odSchema._id
                    };
                    var url = '/opendata/' + s.dataset.entityFullname + '#' + encodeURIComponent(JSON.stringify(params));
                    r_html += row_tmpl.replace(/%title%/g, s.name).replace(/%version%/g, s.version).replace(/%date%/g, d).replace(/%master%/g, master).replace(/%url%/g, url);
                }
                b_html += block_tmpl.replace(/%title%/g, links[l].name).replace(/%rows%/g, r_html);

            }
            $('#rowLinksWrapper').html(b_html);
            $("#rowLinksScrollWrapper").mCustomScrollbar();
            $('#rowLinksContainer').addClass('active');
            $('#historyContainer').addClass('links_opened');



        },
        changeHash: function(key,val) {
            var hash = {};
            if (window.location.hash.length > 1) {
                try {
                    hash = JSON.parse(decodeURIComponent(window.location.hash.substr(1)));
                } catch (err) {
                    console.log(err);
                }
            } else if (key == '') return false;
            if (typeof val != 'undefined') {
                hash[key] = val;
                window.location.hash = JSON.stringify(hash);
            } else if (key == '') {
                return hash;
            } else {
                return hash[key];
            }

        },
        markError: function(elem) {
            var n = $('#diff input[type="checkbox"]:checked').length;
            if (!n) {
                $('#sendErrorContainer').removeClass('active');
                $('#sendErrorContainer').find(".captWrapper").html()
                return;
            }
            var err_text;
            var base = n - Math.floor(n / 100) * 100;
            var result;

            if (base > 9 && base < 20) {
                result = 'ошибок';

            } else {
                var remainder = n - Math.floor(n / 10) * 10;

                if (1 == remainder) result = 'ошибка';
                else if (0 < remainder && 5 > remainder) result = 'ошибки';
                else result = 'ошибок';
            }
            $('.history_errors').show().find('.visible span').html('&nbsp;' + n + ' ' + result);
            if (elem.prop('checked')) {
                var tmpl = $('#send_error_template').html();
                var html = tmpl.replace(/%id%/g, elem.data('path')).replace(/%title%/g, elem.siblings('label').text()).replace(/%value%/g, elem.siblings('div').text());
                $('#sendErrors').append(html);
                $('#sendErrorScrollWrapper').mCustomScrollbar();
            } else {
                $('.send_error_block[data-id="' + elem.data('path') + '"]').remove();
            }
            $('#sendErrorContainer').addClass('active');
            $('#sendErrorContainer').find(".captWrapper").html("<img src='/feedback/captcha?"+(new Date()-1)+"'/>")
        },
        sendRequest: function(elem) {
            var data = {};
            var err = false;
            elem.parents('.send_request_container').find('input, select, textarea').each(function(i,e) {
                if ($(e).parents('#sendErrors').length) return;
                if (($(e).parents('.form_group').hasClass('req') && $(e).val() != '') || $(e).val() != '') {
                    data[$(e).attr('name')] = $(e).val();
                    $(e).parents('.form_group').removeClass('error');
                } else if ($(e).parents('.form_group').hasClass('req') && $(e).val() == '') {
                    $(e).parents('.form_group').addClass('error');
                    err = true;
                }
            });
            data.messages = [];
            elem.parents('.send_request_container').find('.send_error_block').each(function(i,e) {
                var textarea = $(e).find('textarea');
                if (textarea.val()) {
                    textarea.removeClass('error');
                    data.messages.push({
                        path: 'data.' + $(e).data('id'),
                        comment: textarea.val()
                    });
                } else {
                    textarea.addClass('error');
                    err = true;
                }
            });
            if (err) return;
            if (elem.hasClass('send_row_errors'))
                data.odRow = {
                    collectionName: Data.schema.collectionName,
                    doc: Data.currentRow.id
                };
            else if ($('#dataset_id').length)
                data.dataset = $('#dataset_id').val();

            $.ajax({
                url: '/feedback',
                data: data,
                dataType:'json',
                type: 'post',
                success: function(d) {
                    if (d.success) {
                        Act.showPopup('.popup_success');
                        $('#sendErrorContainer').removeClass('active');
                        $('.capt_wrapper').removeClass('error');f
                    } else
                        alert('Ошибка отправки');
                },
                error: function(a,b,c) {
                    if (a.status == 401) $('.capt_wrapper').addClass('error');
                    else {
                        $('.capt_wrapper').removeClass('error');
                        Act.alertAjaxError(a,b,c,'Ошибка отправки');
                    }
                }
            });
        },
        getDatasetMapData: function(callback) {
            var id = $("#dataset_id").val();
            var ver = $('#version_select').val();
            if (!ver) {
                setTimeout(function() {
                    Act.getDatasetMapData(callback);
                }, 200);
                return;
            }
            $.ajax({
                url: '/v1/@' + id + '/@' + ver + '/$fields',
                success: function(d) {
                    var fields = d.data.sort(function(a,b) {
                        return a.schema.table - b.schema.table;
                    });
                    Data.filter_fields = [];
                    Data.geo_fields = [];
                    for (var f in fields) {
                        if (fields[f].schema.table && fields[f].schema.logicalType != 'MapPosition' && fields[f].schema.logicalType != 'GeoJSON') {
                            Data.filter_fields.push(fields[f]);
                        }
                        if (fields[f].schema.logicalType == 'MapPosition' || fields[f].schema.logicalType == 'GeoJSON') {
                            Data.geo_fields.push(fields[f]);
                        }
                    }
                    if (!$('#map_filters').html()) {
                        var html = '';
                        for (var f in Data.filter_fields) {
                            html += '<input type="text" name="' + Data.filter_fields[f].path + '" placeholder="' + Data.filter_fields[f].title + '">';
                        }
                        $('#map_filters').html(html);
                    }
                    if (!Data.geo_fields.length) {
                        $('.build_map').remove();
                        if (window.location.hash.indexOf('build_map') > 0)
                            $('.build_passport').click();
                        return;
                    }
                    if (typeof callback == 'function') callback();
                },
                error: function(a,b,c) {
                    Act.alertAjaxError(a,b,c,'Ошибка получения списка полей');
                }
            });
        },
        initMap: function(firstInit) {
            var ver = $('#version_select').val();
            if (!ver) {
                setTimeout(function() {
                    Act.initMap(firstInit);
                }, 200);
                return;
            }
            if (!Data.geo_fields) return;
            var Types = require("types.js");
            var geo_fields = Data.geo_fields.map(function (fld) {
                var k=fld.path.indexOf("[");
                if (k<0)
                    return "data." + fld.path
                return "data." + fld.path.substr(0,k);
            });
            var geoFieldMap = Data.geo_fields.map(function (fld) {
                return Types.factory(fld, "data." + fld.path)
            });
            var listField= 'data.' + Data.schema.nativeListField;
            var data = {
                sel: geo_fields.join(' ') + ' ' + listField,
                l: 5000,
                f: {},
                // a: 'total'
            };
            var odSet = $('#dataset_id').val();
            if (firstInit) {
                $('.map_wrapper').css('height', window.innerHeight - 200);
                $(window).resize(function () {
                    $('.map_wrapper').css('height', window.innerHeight - 200);
                });
            }
            $('#map_filters input').each(function(i,e) {
                if ($(e).val()) {
                    data.f['data.' + $(e).attr('name')] = $(e).val();
                }
            });
            if ($('#table_search').val()) data.f["$text"] = $('#table_search').val();
            if (data.f != {}) data.f = JSON.stringify(data.f);
            $.ajax({
                url: '/v1/@' + odSet + '/@' + ver,
                data: data,
                success: function(d) {
                    var center = [65,89];
                    var zoom = 4;
                    if (Act.changeHash('map')) {
                        center = Act.changeHash('map');
                        center = [center.lat, center.lng];
                        var id = center.id;
                        zoom = 18;
                        var enabled = false;
                    }
                    var points = [];
                    var Obj = {};
                    if (window.location.hash.length > 1) {
                        Obj = JSON.parse(decodeURIComponent(window.location.hash.substr(1)));
                    }
                    var prev_tar;
                    function pushOneCoo(fld, coords) {
                        var selected = false;
                        // TODO: rewrite that for other geoJSON types
                        coords=fld.convertCoordinates(coords);
                        if (typeof coords != 'undefined' && coords) {
                            if (Obj.point && Obj.point == d.data[p]._id) {
                                selected = true;
                                enabled = true;
                            } else if (coords[0] == center[0] && coords[1] == center[1]) {
                                enabled = true;
                                selected = true;
                            }
                            points.push({
                                id: d.data[p]._id,
                                coords: coords,
                                title: mpath.get(listField, d.data[p]) || "",
                                selected: selected
                            });
                        }
                    }
                    for (var p in d.data) {
                        geoFieldMap.forEach(function(fld){
                            var k=fld.path.indexOf("[");
                            if (k<0) {
                                pushOneCoo(fld, mpath.get('data.' +fld.path, d.data[p]) );
                            } else {
                                var z=0;
                                var coords=true;
                                while(coords) {
                                    var onePath=('data.' +fld.path).replace("[]", "."+z);
                                    coords= mpath.get(onePath, d.data[p]);
                                    pushOneCoo(fld, coords);
                                    z++;
                                }
                            }
                        })
                    }
                    if (typeof enabled != 'undefined' && !enabled)
                        points.push({
                            id: id,
                            coords: center,
                            title: localStorage.icon_title,
                            selected: true
                        });
                    var total = d.total || d.count || d.limit;
                    if (!(total < d.limit)) {
                        
                        $("#map_results_count").css('visibility', 'visible');
                        $("#map_results_count span").eq(0).text(" возможно больше "+total + ' ' + Act.getNumEnding(total, ['строка', 'строки', 'строк']));
                        $("#map_results_count span").eq(1).text('Показаны первые' + ' ' + d.limit);
                    } else {
                        $("#map_results_count").css('visibility', 'hidden');
                    }

                    ymaps.ready(function () {
                        if (Data.myMap) Data.myMap.destroy();

                        var customBalloonContentLayout = ymaps.templateLayoutFactory.createClass([
                            '<ul class=cluster_list>',
                            // Выводим в цикле список всех геообъектов.
                            '{% for geoObject in properties.geoObjects %}',
                            '<li><a href=# data-placemarkid="{{ geoObject.properties.point_id }}" class="cluster_list_item">{{ geoObject.properties.clusterCaption }}</a></li>',
                            '{% endfor %}',
                            '</ul>'
                        ].join(''));
                        $(document).on( "click", "a.cluster_list_item", function(e) {
                            e.preventDefault();
                            $(this).parents('li').addClass('active').siblings().removeClass('active');
                            buildMapCard($(this).data().placemarkid);
                        });

                        Data.myMap = new ymaps.Map('map', {
                            center: center,
                            zoom: zoom,
                            behaviors: ['default', 'scrollZoom'],
                            controls: []
                        }, {
                            searchControlProvider: 'yandex#search'
                        }),
                            clusterer = new ymaps.Clusterer({
                                preset: 'islands#invertedNightClusterIcons',
                                groupByCoordinates: false,
                                clusterDisableClickZoom: true,
                                clusterHideIconOnBalloonOpen: false,
                                geoObjectHideIconOnBalloonOpen: false,
                                clusterBalloonContentLayout: customBalloonContentLayout
                            }),
                            getPointData = function (title, id) {
                                return {
                                    balloonContentBody: title,
                                    clusterCaption: title,
                                    point_id: id
                                };
                            },
                            geoObjects = [];



                        var h = $('#map_filters').height() + parseInt($('#map_filters').css('top'));
                        Data.myMap.controls.add('zoomControl', {
                            size: "small",
                            position: {
                                left: 20,
                                top: h + 110
                            }
                        });
                        var geolocationControl = new ymaps.control.GeolocationControl({
                            options: {
                                position: {
                                    left: 20,
                                    top: h + 77
                                }
                            }
                        });
                        Data.myMap.controls.add(geolocationControl);

                        var currentPoint = false;
                        for(var i = 0, len = points.length; i < len; i++) {
                            var preset = points[i].selected ? 'islands#redDotIcon' : 'islands#nightIcon';
                            geoObjects[i] = new ymaps.Placemark(points[i].coords, getPointData(points[i].title, points[i].id), { preset:preset, openBalloonOnClick: false });
                            if (points[i].selected) {
                                currentPoint = geoObjects[i];
                                prev_tar = currentPoint;
                            }
                        }

                        clusterer.options.set({
                            gridSize: 80,
                            clusterDisableClickZoom: true
                        });
                        console.log(geoObjects);
                        clusterer.add(geoObjects);
                        Data.myMap.geoObjects.add(clusterer);
                        clusterer.events.add('click', function (e) {
                            clusterer.balloon.close();
                            e.preventDefault();
                            var tar = e.get('target');
                            var clusterPlacemark = tar.options._name == 'cluster';
                            var cur_id = false;
                            if (!prev_tar) prev_tar = tar;
                            if (!clusterPlacemark) {
                                cur_id = tar.properties._data.point_id;
                            } else {
                                var isInOne = true;
                                var objs = tar.properties._data.geoObjects;
                                for (var o in objs) {
                                    var coords = objs[o]._geoObjectComponent._geometry._coordinates;
                                    for (var a in objs) {
                                        var c = objs[a]._geoObjectComponent._geometry._coordinates;
                                        if (c[0] != coords[0] && c[1] != coords[1]) isInOne = false;
                                    }
                                }
                                if (!isInOne) {
                                    var zoom = Data.myMap.getZoom() + 2;
                                    zoom = zoom > 18 ? 18 : zoom;
                                    Data.myMap.setZoom(zoom);
                                    Data.myMap.setCenter(tar.geometry._coordinates);
                                } else {
                                    cur_id = clusterPlacemark.state.get('activeObject').properties._data.point_id;
                                    var optionMonitor = new ymaps.Monitor(clusterPlacemark.state);
                                    optionMonitor.add("activeObject", function (newValue) {
                                        cur_id = newValue.properties._data.point_id;
                                        buildMapCard();
                                    });
                                }
                            }
                            prev_tar.options.set('preset', 'islands#nightIcon');
                            tar.options.set('preset', 'islands#redDotIcon');
                            prev_tar = tar;
                            buildMapCard(cur_id);
                        });
                        $("#map_card .close_card").on('click', function() {
                            prev_tar.options.set('preset', 'islands#nightIcon');
                        });
                        if (Obj.point) buildMapCard(Obj.point);
                        function buildMapCard(cur_id) {
                            if (!cur_id) return;
                            var url="/v1/@"+odSet+"/@" + ver;
                            var reqData={
                                f:JSON.stringify({_id:cur_id,odSchema:'$',inactivated:{$exists:false}}),
                                p:"odSetVersions odSchema",
                                l:5000
                                //  o:"modified"
                            };
                            $.ajax({
                                url:url,
                                data:reqData,
                                method:'GET',
                                headers:{"Accept":"application/json"},
                                error:function(jqXHR, textStatus, errorThrown) {
                                    alert("Не удалось получить данные. Статус операции:"+textStatus);
                                    console.error("Can't get row history data", textStatus, url);
                                },
                                success: function(data, status) {
                                    renderHistoryData(data);
                                    var obj = {};
                                    if (window.location.hash.length > 1)
                                        obj = JSON.parse(window.location.hash.substr(1));
                                    obj.point = cur_id;
                                    obj.map = '';
                                    window.location.hash = JSON.stringify(obj);
                                }
                            });
                            function renderHistoryData(responseData) {
                                var diffBlock=$("#detail");
                                diffBlock.empty();
                                var rows=responseData.data;
                                var versions=[];
                                rows.forEach(function(nativeEntity, j){
                                    nativeEntity.odSetVersions.forEach(function(aVersion, i){
                                        var errors={};
                                        if ($.isArray(nativeEntity.errorFields) ) {
                                            nativeEntity.errorFields.forEach(function(e){
                                                errors[e.dataPath.substr(1)]=e.message;
                                            })
                                        };
                                        versions.push({time:aVersion.snapshotTime, version:aVersion.version, _id:nativeEntity._id, data:nativeEntity.data, version_id:aVersion._id, errors:errors });
                                    });
                                });
                                versions=versions.sort(function(a,b){return (a.time>b.time?-1: a.time<b.time?1:0) });
                                updateDiff(0);
                                $('#map_card').addClass('active').find('.map_card_scroll_wrapper').mCustomScrollbar();
                                function updateDiff(index) {
                                    index = index ? index : 0;
                                    var oneRowData=versions[index];
                                    var prevData;
                                    if (index<versions.length-1)
                                        prevData=versions[index+1].data;

                                    showDiff(oneRowData.data, prevData, oneRowData.errors);
                                }
                            }
                            var getPath = function(obj, path) {
                                var parts = path.split('.');
                                while (parts.length && (obj = obj[parts.shift()] ) );
                                return obj;
                            };

                            function showDiff(a, b, errors, c, d) {
                                var jsonSchema;
                                jsonSchema = JSON.parse(Data.schema.schemaText);
                                var container= typeof c == 'undefined' ? $("div#map_diff") : c;
                                var schema = typeof d == 'undefined' ? jsonSchema : d;
                                b = b || {};
                                var diffs=DeepDiff.diff(b, a) || [];

                                function difStatus(path) {
                                    var sp=path.split(".");
                                    var d=diffs.filter(function(d){
                                        var p=d.path;
                                        if (!p) return false;
                                        if (p.length!=sp.length)
                                            return false;
                                        for(var i=0;i<p.length;i++)
                                            if (p[i]!=sp[i])
                                                return false;
                                        return true;
                                    });
                                    return d.length?d[0]:false;
                                }
                                function _emptyVal(val, fldType) {
                                    if (fldType)
                                        return fldType.toHTML(val)
                                    else
                                        return (val?val:"пусто");
                                }
                                function item(obj, value, key, path) {
                                    if (!obj)
                                        return {value:"", isEmpty:true};
                                    if ($.isArray(obj.type) ) {
                                        obj.type=obj.type.filter(function(a){ return (a!="null"); });
                                        obj.type=obj.type.length?obj.type[0]:"null";
                                    }

                                    var itemPath=path.substr(1);
                                    var isErrors=false;//(itemPath in errors);
                                    var errClass=isErrors?" errorLine":"";
                                    if (obj.type=="array" && obj.items)  {
                                        var diff = difStatus(path.substr(1));
                                        var cl="";
                                        var addon="";
                                        var fldType = Types.factory(obj, path.substr(1));
                                        if (diff) {
                                            if (diff.kind=="N")
                                                cl="inserted";
                                            else
                                            if (diff.kind=="A" ||  diff.kind=="E" || diff.kind=="D") {
                                                addon="<div class='deleted'>"+_emptyVal(diff.lhs, fldType)+"</div>";
                                                cl=diff.kind=="E"?"modified":"deleted";
                                            }
                                        }
                                        var res=[];
                                        if (!fldType) {
                                            var subs=[];
                                            var isAllEmpty=true;
                                            var sub={isEmpty:false};
                                            for(var i=0; !sub.isEmpty && i<MAX_ARRAY_ITEMS; i++) {
                                                var sub=item(obj.items, value, i, path+"."+i);
                                                isAllEmpty = isAllEmpty && sub.isEmpty;
                                                if (!sub.isEmpty)
                                                    subs.push(sub.value);
                                            }

                                            res.push("<label class='"+cl+(isAllEmpty?" empty":"")+"'> "+(obj.title?obj.title:"")+"</label>"+addon);
                                            res.push("<ol class='"+cl+(isAllEmpty?" empty":"")+"'><li>");
                                            res.push(subs.join("</li>\n<li>"));
                                            res.push("</li></ol>");
                                            if (value['general'][key] && value['general'][key].length > MAX_ARRAY_ITEMS) {
                                                res.push("<div class='hiddenElems'>Список содержит еще " + (value['general'][key].length - MAX_ARRAY_ITEMS) +  " элементов, доступных в API</div>");
                                            }
                                            return {value:res.join("\n"), isEmpty:isAllEmpty};
                                        } else {
                                            var val= getPath(value, itemPath) || "";
                                            res.push("<div class='"+cl+(!val?" empty":"")+errClass+"' a='2' ><input type='checkbox' data-path='"+itemPath+"'"+(isErrors?" checked ":"")+"><label>"+(obj.title || fldType.title)+"</label></div>"+addon);
                                            res.push(_emptyVal(val, fldType));
                                            return {value:res.join("\n"), isEmpty:!val};
                                        }

                                    }
                                    else

                                    if (obj.type=="object" || (!obj.type && obj.properties) )  {
                                        var diff = difStatus(path.substr(1));
                                        var cl="";
                                        var addon="";
                                        var fldType = Types.factory(obj, path.substr(1));
                                        if (diff) {
                                            if (diff.kind=="N")
                                                cl="inserted";
                                            else
                                            if (diff.kind=="A" ||  diff.kind=="E" || diff.kind=="D") {
                                                addon="<div class='deleted'>"+_emptyVal(diff.lhs, fldType)+"</div>";
                                                cl=diff.kind=="E"?"modified":"deleted";
                                            }
                                        }
                                        var res=[];

                                        if (!fldType && obj.properties) {

                                            var subs=[];
                                            var isAllEmpty=true;
                                            for(var p in obj.properties) {
                                                var sub=item(obj.properties[p], value, p, path+"."+p);
                                                isAllEmpty = isAllEmpty && sub.isEmpty;
                                                subs.push(sub.value);
                                            }
                                            if (obj.title)
                                                res.push("<label class='"+cl+(isAllEmpty?" empty":"")+"'>"+obj.title+"</label>");
                                            res.push(addon);
                                            res.push("<ul class='"+cl+(isAllEmpty?" empty":"")+"'><li>");
                                            res.push(subs.join("</li>\n<li>"));
                                            res.push("</li></ul>");
                                            return {value:res.join("\n"), isEmpty:isAllEmpty};
                                        } else {
                                            var val= getPath(value, itemPath) || "";
                                            res.push("<div class='"+cl+(!val?" empty":"")+errClass+"' a='2' ><input type='checkbox' data-path='"+itemPath+"'"+(isErrors?" checked ":"")+"><label>"+(obj.title || fldType.title)+"</label></div>"+addon);
                                            res.push(_emptyVal(val, fldType));
                                            return {value:res.join("\n"), isEmpty:!val};
                                        }

                                    }
                                    else {

                                        var val= getPath(value, itemPath) || "";
                                        var diff = difStatus(itemPath);
                                        var cl="";
                                        var addon="";
                                        var fldType = Types.factory(obj, itemPath);
                                        if (diff) {
                                            if (diff.kind=="A" || diff.kind=="N")
                                                cl="inserted";
                                            else
                                            if (diff.kind=="E" || diff.kind=="D") {
                                                addon="<div class='deleted'>"+_emptyVal(diff.lhs, fldType)+"</div>";
                                                cl=diff.kind=="E"?"modified":"deleted";
                                            }
                                        }

                                        var links_class = '';
                                        /* if ($.inArray(itemPath, Data.links_path) != -1) {
                                         links_class = 'link_enable';
                                         } */
                                        var label=($.isNumeric(key)?"":(obj.title || key));
                                        var htm="<div class='"+cl+(!val?" empty":"")+errClass+"'><input type='checkbox' data-path='"+itemPath+"'"+(isErrors?" checked ":"")+">"+
                                            (label?"<label class='" + links_class + "'> "+label+"</label>":"")+
                                            addon+"<div a='3'>"+_emptyVal(val, fldType)+"</div></div>";
                                        return  { isEmpty:!val, value:htm};
                                    }

                                }

                                container.html("<div class='diffs'>"+item(schema, a,  "", "").value+"</div>" ); // +"<pre>"+JSON.stringify(diffs)+"</pre>"
                            }
                        }

                        if (currentPoint) {
                            var geoObjectState = clusterer.getObjectState(currentPoint);
                            // Проверяем, находится ли объект в видимой области карты.
                            if (geoObjectState.isShown) {

                                // Если объект попадает в кластер, открываем балун кластера с нужным выбранным объектом.
                                if (geoObjectState.isClustered) {
                                    geoObjectState.cluster.state.set('activeObject', currentPoint);
                                    //clusterer.balloon.open(geoObjectState.cluster);
                                    geoObjectState.cluster.options.set('preset', 'islands#invertedRedClusterIcons');
                                    //prev_tar = geoObjectState.cluster;
                                } else {
                                    // Если объект не попал в кластер, открываем его собственный балун.
                                    //currentPoint.balloon.open();
                                }
                            }
                        }
                    });
                },
                error: function(a,b,c) {
                    console.log(a,b,c);
                    //Act.alertAjaxError(a,b,c,'Ошибка получения гео-данных');
                    var center = [65,89];
                    var zoom = 4;
                    if (Data.myMap) Data.myMap.destroy();
                    Data.myMap = new ymaps.Map('map', {
                        center: center,
                        zoom: zoom,
                        behaviors: ['default', 'scrollZoom'],
                        controls: []
                    });
                }
            });
        },
        userRateMove: function(e) {
            if ($('.user_rating').hasClass('inactive')) return;
            var uw = $('.user_rating').width();
            var sw = 40;
            var mark = ((e.offsetX/uw)*100)/sw;
            mark = Math.round(mark*2)/2;
            var w = mark * sw;
            if (w < 0) w = 0;
            if (w > uw) w = uw;
            $('.user_rating div').css('width', w);
        },
        sendUserRate: function(e) {
            if ($('.user_rating').hasClass('inactive')) return;
            $('.user_rating').addClass('inactive');
            var uw = $('.user_rating').width();
            var sw = 40;
            var mark = ((e.offsetX/uw)*100)/sw;
            mark = Math.round(mark*4)/2;
            $.ajax({
                url: '/feedback/mark',
                type: 'post',
                data: {
                    odSet: $('#dataset_id').val(),
                    mark: mark
                },
                success: function() {
                    $('.rate_dataset').removeClass('active');
                    Act.showPopup('.popup_vote');
                },
                error: function(a,b,c) {
                    Act.alertAjaxError(a,b,c,"Не удалось сохранить оценку");
                }
            });
        },
        fillAboutLists: function() {
            $('#about_content .about_tab > ul.num').each(function(b,e) {
                $(e).children('li').each(function(i,li) {
                    i += 1;
                    $(li).prepend('<span class="numlist_mark">' + i + '</span>');
                    if ($(li).find('ul.num').length) {
                        $(li).find('ul.num li').each(function(j,l) {
                            j += 1;
                            $(l).prepend('<span class="numlist_mark">' + i + '.' + j + '</span>');
                        });
                    }
                });
            });
        },
        showDatasetLinks: function() {
            var block_tmpl = $('#schema_links_block_template').html();
            var row_tmpl = $('#card_link_row_template').html();
            var b_html = '', r_html;
            var links = Data.links;
            for (var l in links) {
                r_html = '';
                for (var r in links[l].odSchema) {
                    var s = links[l].odSchema[r];
                    var d = moment(s.modified).format("DD-MM-YYYY");
                    var master = s.master ? 'master_schema' : '';
                    var params = {
                        tab: 'build_table'
                    };
                    var url = '/opendata/' + s.dataset.entityFullname + '#' + encodeURIComponent(JSON.stringify(params));
                    r_html += row_tmpl.replace(/%title%/g, s.name).replace(/%version%/g, s.version).replace(/%date%/g, d).replace(/%master%/g, master).replace(/%url%/g, url);
                }
                b_html += block_tmpl.replace(/%title%/g, links[l].field.title).replace(/%rows%/g, r_html);
            }
            $("#linksSchemas").html(b_html);
            $('#linksContainer').addClass('active');
            $('#linksScrollWrapper').mCustomScrollbar();
        },
        slideShowNext: function() {
            var cur = $('.index_slide.active');
            var next = cur.next('.index_slide').length ? cur.next('.index_slide') : $('.index_slide').first();
            cur.removeClass('active');
            next.addClass('active');
        },
        slideShowPrev: function() {
            var cur = $('.index_slide.active');
            var prev = cur.prev('.index_slide').length ? cur.prev('.index_slide') : $('.index_slide').last();
            cur.removeClass('active');
            prev.addClass('active');
        },
        sendSubscribe: function() {
            var err = false;
            var data = {};
            $('.popup_subscribe .active input, .popup_subscribe .active select').each(function(i,e) {
                var v = $(e).val();
                if (v == '') {
                    $(e).addClass('error');
                    err = true;
                } else {
                    $(e).removeClass('error');
                    data[$(e).attr('name')] = v;
                }
            });
            if (err) return;
            $.ajax({
                url: '/notify/subscribe',
                method: 'post',
                data: data,
                success: function(d) {
                    Act.showPopup('.popup_subscribe_success');
                },
                error: function(a,b,c) {
                    Act.alertAjaxError(a,b,c,'Ошибка отправки');
                }
            });
        },
        getNumEnding: function(iNumber, aEndings) {
            var sEnding, i;
            iNumber = iNumber % 100;
            if (iNumber>=11 && iNumber<=19) {
                sEnding=aEndings[2];
            }
            else {
                i = iNumber % 10;
                switch (i)
                {
                    case (1): sEnding = aEndings[0]; break;
                    case (2):
                    case (3):
                    case (4): sEnding = aEndings[1]; break;
                    default: sEnding = aEndings[2];
                }
            }
            return sEnding;
        }
    };
    Act.init();

    $('body').on('click', '*', function(e) {
        var _this = e.target;
        if (!$(_this).hasClass('download_btn') && !$(_this).parents('.download_btn').length)
            $('.download_btn').removeClass('active');
        if (!$(_this).hasClass('rate_dataset') && !$(_this).parents('.rate_dataset').length)
            $('.current_dataset_stats').removeClass('active');

    }).on('click', '.download_btn span', function(e) {
        e.preventDefault();
        $('.download_btn').removeClass('active');
        $(this).parent().toggleClass('active');
    }).on('click', '.filter_aside_block', function() {
        if (!$(this).hasClass('active')) Act.changeCategory($(this));
    }).on('change', '#datasets_limit', function() {
        Act.reloadDatasets();
        Act.buildPaginator();
    }).on('change', '#datasets_sort', function() {
        if ($(this).val() == '') {
            $('#sort_type').removeClass('asc').addClass('desc');
        } else {
            $('#sort_type').removeClass('desc').addClass('asc');
        }
        Act.reloadDatasets();
    }).on('click', '#sort_type', function() {
        $(this).toggleClass('asc');
        $(this).toggleClass('desc');
        Act.reloadDatasets();
    }).on('click', '.sort_btn', function() {
        Act.reloadDatasetsStat($(this));
    }).on('click', '.download_format', function() {
        Act.startDownload($(this));
    }).on('change', '#schema_select', function() {
        Act.changeHash('schema', $(this).val());
        Act.getDatasetMapData();
        Act.buildDatasetVersions();
    }).on('change', '#version_select', function() {
        Act.changeHash('version', $(this).val());
        if ($('.build_table').hasClass('active'))
            Act.buildDatasetTable();
        if ($('.build_map').hasClass('active'))
            Act.initMap();
    }).on('click', '.show_legend, .show_full_schema, .history_errors', function() {
        $(this).toggleClass('show');
        if ($(this).hasClass('history_errors')) {
            $('#diff input').toggle();
            $('#diff').toggleClass('mark_error_mode');
        }
    }).on('click', '.link_enable', function() {
        Act.openRowLinks($(this));
    }).on('click', '.closeWindow', function() {
        var disabled = $('#dataset_table').attr("data-disabled");
        if (disabled - 0) return;
        $(this).parents('.sideWindow').removeClass('active');
    }).on('click', '#rowLinksContainer .closeWindow', function() {
        $('#historyContainer').removeClass('links_opened');
    }).on('click', '#historyContainer .closeWindow', function() {
        $('#rowLinksContainer').removeClass('active');
        $('#historyContainer').removeClass('links_opened');
        var hash = Act.changeHash('');
        delete hash.row;
        window.location.hash = JSON.stringify(hash);
    }).on('click', '.tab_button', function() {
        Act.switchTab($(this));
    }).on('change', '#diff input[type="checkbox"]', function() {
        Act.markError($(this));
    }).on('click', '#popup_wrapper, .popup_close', function(e) {
        if ($(this).hasClass('popup_close') || $(e.target).attr('id') == 'popup_wrapper') {
            Act.hidePopup();
        }
    }).on('click', '.not_found_row', function() {
        Act.showPopup('.popup_add_row');
    }).on('click', '.passport_error', function() {
        Act.showPopup('.popup_passport_error');
    }).on('click', '.dataset_renew', function() {
        Act.showPopup('.popup_dataset_renew');
    }).on('click', '.request_new_dataset', function(e) {
        e.preventDefault();
        Act.showPopup('.popup_new_dataset');
    }).on('click', '.send_request_container .popup_submit', function() {
        Act.sendRequest($(this));
    }).on('keyup', '#map_filters input', function() {
        var that = this;
        if (typeof Data.filters_timer != 'undefined') clearTimeout(Data.filters_timer);
        Data.filters_timer = setTimeout(function() {
            $('#dataset_table th input[name="data.' + $(that).attr('name') + '"]').val($(that).val()).trigger('keyup');
            Act.initMap();
        }, 1000);
    }).on('mousemove', '.user_rating', function(e) {
        Act.userRateMove(e);
    }).on('click', '.user_rating', function(e) {
        Act.sendUserRate(e);
    }).on('mouseleave', '.user_rating', function(e) {
        if (!$('.user_rating').hasClass('inactive')) {
            $('.user_rating div').css('width', Data.rating_width);
        }
    }).on('click', '.rate_dataset', function(e) {console.log(123);
        if (!$(e.target).hasClass('user_rating') && !$(e.target).parents('.user_rating').length && !$(e.target).hasClass('current_dataset_stats') && !$(e.target).parents('.current_dataset_stats').length)
            $('.current_dataset_stats').toggleClass('active');
    }).on('click', '.dataset_info', function(e) {
        if ($(e.target).parents('.dataset_info').length) return;
        if ($(this).hasClass('active')) {
            $('.dataset_info').removeClass('active');
        } else {
            $('.dataset_info').removeClass('active');
            $(this).addClass('active');
        }
    }).on('click', '.show_full_screen', function() {
        $(this).parents('.sideWindow').toggleClass('fullWidth');
    }).on('click', '.show_legend', function() {
        $(this).parents('.sideWindow').toggleClass('showChanges').find('.history_legend').toggleClass('visible');
    }).on('click', '.show_full_schema', function(e) {
        $(this).parents('.sideWindow').toggleClass('showEmpty');
    }).on('click', '.about_menu_point', function(e) {
        if ($(this).data('sel')) {
            e.preventDefault();
            $($(this).parent().data('sel')).removeClass('active').siblings($(this).data('sel')).addClass('active');
            $(this).addClass('active').siblings().removeClass('active');

        }
    }).on('keypress', '.search_field, #main_search', function(e) {
        if (e.keyCode == 13)
            window.location.href = "/item/search/" + $(this).val();
    }).on('click', '.dataset_cat', function() {
        Act.selectCategory($(this));
    }).on('click', '.search_btn', function() {
        if ($(this).hasClass('active')) {
            $('.search_btn, #search_line').removeClass('active');
            $('#search_opened').fadeOut(300);
        } else {
            $('.search_btn, #search_line').addClass('active');
            $('#search_opened').fadeIn(300);
            $('#main_search').focus();
        }
    }).on('click', '.search_submit', function() {
        window.location.href = "/item/search/" + $('#main_search').val();
    }).on('click', '.show_links', function() {
        Act.showDatasetLinks();
    }).on('click', '.index_arr_right', function() {
        Act.slideShowNext();
    }).on('click', '.index_arr_left', function() {
        Act.slideShowPrev();
    }).on('click', '.paginator_page', function() {
        $(this).addClass('active').siblings().removeClass('active');
        if ($('#datasets_wrapper').length) {
            Act.reloadDatasets();
        } else {
            Act.reloadDatasetsStat();
        }
    }).on('click', '.subscribe', function(e) {
        e.preventDefault();
        Act.showPopup('.popup_subscribe');
    }).on('click', '.popup_subscribe .popup_submit', function() {
        Act.sendSubscribe();
    }).on('change', '.popup_subscribe select', function() {
        if ($(this).val() == 'get' || $(this).val() == 'post') {
            $('.subscribe_url').addClass('active');
        } else {
            $('.subscribe_url').removeClass('active');
        }
    }).on("click", ".MapLink", function(){
        var el = $(this);
        var lat = el.data('lat');
        var lng = el.data('lng');
        localStorage.setItem('icon_title', $('#dataset_table tr.active').find('.native_name').text());
        if (lat && lng)
            Act.switchTab($('.build_map'), {name: 'map', value: {'lat' : lat, 'lng' : lng}});
    }).on('click', '.close_card', function() {
        $('#map_card').removeClass('active');
        var hash = Act.changeHash('');
        delete hash.point;
        window.location.hash = JSON.stringify(hash);
    }).on('click', '.paginate_button ', function() {
        window.scrollTo(0, $('.dataset_tabs').offset()['top']);
    }).on('click', '#versions_scroll_up, #versions_scroll_down', function() {
        if ($(this).hasClass('disabled')) return;
        var dir = -1;
        if ($(this).attr('id') == 'versions_scroll_down') dir = 1;
        var d = $('#detail');
        var v = $('#versions_wrapper');
        var vh = v.height() - 48;
        var scrollScreens = Math.ceil(d.height() / vh);
        var currentScreen = Math.floor(parseInt(d.css('top')) / -vh);
        d.animate({top: -vh * (currentScreen + dir)}, 300, function() {
            if ((currentScreen + dir) == 0) $('#versions_scroll_up').addClass('disabled');
            else $('#versions_scroll_up').removeClass('disabled');
            if ((currentScreen + dir) == scrollScreens - 1) $('#versions_scroll_down').addClass('disabled');
            else $('#versions_scroll_down').removeClass('disabled');
        });
    }).on('click', '.remove_filter', function() {
        if (window.location.hash.length > 1) {
            var obj = {};
            obj = JSON.parse(decodeURIComponent(window.location.hash.substr(1)));
            delete obj.link;
            window.location.hash = JSON.stringify(obj);
        }
        $('.filtered_by, .remove_filter').hide();
        Act.buildDatasetTable();
    });
});